/********************************************************************
   TORNADO-PX/DDC4 DCM Demo Utility.
   ADC Overflow Demo. rev.1A
   (C) MicroLAB Systems, 2000


   Description:
   ------------
	This demo contains ADC overflow test.

   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources
	and runs in stand-alone mode. MIRAGE JTAG emulator and
	TI CCS tools are required to recompile this demo and to
	upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
        on-board configuration switch:
          - SA-mode
	  - no BOOT mode
***********************************************************************/

#include	"math.h"
#include	"c54x_def.h"
#include	"ddc4_dsp.h"
#include	"ddc4_dx.h"



void init_cpu()
 {
	TPXDDC4_init_cpu();
 }

void init_sio()
{
		// init McBSP-1 port
	TPXDDC4_init_mcbsp1();

}

	// set PFG-1 = (100/4*8)=3.1MHz
	// (N=30, M=3, V=0 (1), X=2, R=3)
#define PFG_N_DATA       30
#define PFG_M_DATA       3
#define PFG_V_DATA       0
#define PFG_X_DATA       2
#define PFG_R_DATA       3



unsigned adc1_ovf_count, adc2_ovf_count;

void main()
{ int adc_ovf_clr;


	init_cpu();
	init_sio();

	  	// configure PFG-1
	TPXDDC4_write_pfg(TPXDDC4_PFG1_SEL,
			  PFG_N_DATA,
                          PFG_M_DATA,
                          PFG_V_DATA,
  	  	    	  PFG_X_DATA,
                          PFG_R_DATA);


		// clear ADC clk selector RG:
        TPXDDC4_set_adc_clk_sel(  TPXDDC4_ADC1_CLK_SEL_PFG1
				| TPXDDC4_ADC2_CLK_SEL_PFG1
				| TPXDDC4_PFG1_AUX_FDIV_OFF
				| TPXDDC4_PFG2_AUX_FDIV_OFF
			       );


		// clear counters for ADC OVERFLOW events
        adc1_ovf_count=0;
	adc2_ovf_count=0;
        TPXDDC4_clr_adc_ovf();	// clear ADC ovf flags if they are set

	while (1)
	 {
          adc_ovf_clr=0;

          if(TPXDDC4_adc1_ovf()!=0)
	     {
               adc1_ovf_count++;
               adc_ovf_clr=1;
	     }

          if(TPXDDC4_adc2_ovf()!=0)
	     {
               adc2_ovf_count++;
               adc_ovf_clr=1;
	     }

          if(adc_ovf_clr!=0) TPXDDC4_clr_adc_ovf();

         }
}

