/********************************************************************
   TORNADO-PX/DDC4 DCM Demo Utility.
   DPRAM test. rev.1A
   (C) MicroLAB Systems, 2000


   Description:
   ------------
	This demo writes/reads the test patterns to DPRAM.

	This demo must be loaded into DSP on-chip RAM and requires 
    OVLY bit of C54x PMST reg to be set to '1' when loading program
	via emulator.

   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources
	and runs in stand-alone mode. MIRAGE JTAG emulator and
	TI CCS tools are required to recompile this demo and to
	upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
        on-board configuration switch:
          - SA-mode
	  - no BOOT mode
	  - OVLY bit of C54x PMST register must be set to '1' in order to
	    load this DEMO.
***********************************************************************/

#include	"math.h"
#include	"c54x_def.h"
#include	"ddc4_dsp.h"
#include	"ddc4_dx.h"


init_cpu()
 {
	TPXDDC4_init_cpu();
	TPXDDC4_set_xdm_sel(TPXDDC4_XDM_SEL_DPRAM);	// select DPRAM area
 }

#define	DMEM_START_PTR	((unsigned *) TPXDDC4_DPRAM_SADDR)
#define	DMEM_END_PTR	((unsigned *) (TPXDDC4_DPRAM_EADDR-0x80))


unsigned *ptr ;
unsigned start_data = 0xa596,
         start_data_block;
unsigned mem_inc_data = 0x97b5;
unsigned mem_wr_data;
unsigned long pass_counter=0;

void main()
{
   init_cpu();


   while(1)
    {
      start_data_block= start_data;

          for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      ptr<=DMEM_END_PTR ; *ptr++ = mem_wr_data++);

      start_data=start_data_block;

          for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      ptr<=DMEM_END_PTR ;	)
   	   {
             if(*ptr++ != mem_wr_data++) goto error ;
	   }

     start_data += mem_inc_data ;
     pass_counter++;

    }


  error:
    while(1) ;

}

