/********************************************************************
   TORNADO-PX/DDC4 DCM Demo Utility. rev.1A
   Host DPRAM test for TORNADO-3x/E3x/P3x.
   (C) MicroLAB Systems, 2000


   Description:
   ------------
	This demo performs DPRAM test via host TORNADO-3x/E3x/P3x mainboard.
        T-PX/DDC4 on-board DSP is not utilized for this demo.

   Host TORNADO platform:
   ----------------------
	This demo utilize host TORNADO resources and runs in HOST mode.
	MIRAGE emulator or COFF-loader shall be used to upload
	code to host TORNADO board.

	TI CCS tools are required to recompile this demo and to
	upload code to host TORNADO on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
        on-board configuration switch:
          - HOST-mode
	  - DCM is installed onto TORNADO-3x/E3x/P3x mainboard
***********************************************************************/


#include <c3x_def.h>
#include <t3x_dsp.h>
#include <ddc4_h3x.h>


unsigned *ptr ;

#define	DMEM_START_PTR	((unsigned *) HTPXDDC4_DPRAM_SADDR)
#define	DMEM_END_PTR	((unsigned *) HTPXDDC4_DPRAM_EADDR)

init_cpu()
{
   *C3X_PBUS_GC=T3X_PBUS_GC_DATA;
}


unsigned start_data = 0xe73b,
         start_data_block;
unsigned mem_inc_data = 0xf3be;
unsigned mem_wr_data, mem_rd_data;
unsigned pass_counter=0;


main()
{
   init_cpu();

	// set T-PX/DDC4 DSP to the RESET state
   HTPXDDC4_SET_MRESET;
   if(HTPXDDC4_MRESET_DATA!=HTPXDDC4_MRESET_RESET) goto error;

	// set no-boot and enable DPRAM error control

   HTPXDDC4_SET_CNTR2_RG(  HTPXDDC4_BMODE_NONE
   			 | HTPXDDC4_DPRAM_ERR_EN_ON
			 | HTPXDDC4_HPI_ERR_EN_OFF
                        );
   HTPXDDC4_CLR_DPRAM_ERR;
   if(   HTPXDDC4_CNTR2_RG_DATA!= (  HTPXDDC4_BMODE_NONE
   			 	   | HTPXDDC4_DPRAM_ERR_EN_ON
			 	   | HTPXDDC4_HPI_ERR_EN_OFF
                                  )
      || HTPXDDC4_DPRAM_ERR_DATA!=0
     ) goto error;


   while(1)
    {
      start_data_block= start_data;

      for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
          ptr<=DMEM_END_PTR ; *ptr++ = mem_wr_data++);

      start_data += mem_inc_data ;

      if(HTPXDDC4_DPRAM_ERR_DATA!=0) goto error;
      start_data=start_data_block;

      for(mem_wr_data=start_data, ptr=DMEM_START_PTR; ptr<=DMEM_END_PTR;)
   	   {
	     mem_rd_data = *ptr ;
             if((mem_rd_data & HTPXDDC4_DPRAM_DATA_BITMASK) != (mem_wr_data & HTPXDDC4_DPRAM_DATA_BITMASK) ) goto error ;
	     ++ptr; mem_wr_data++;
	   }
          start_data += mem_inc_data ;
	  start_data &= HTPXDDC4_DPRAM_DATA_BITMASK; 

      if(HTPXDDC4_DPRAM_ERR_DATA!=0) goto error;
      pass_counter++;
    }


  error:
    while(1) ;

}


