/********************************************************************
   TORNADO-PX/DDC4 DCM Demo Utility. rev.1A
   Host I/F registers test for TORNADO-3x/E3x/P3x.
   (C) MicroLAB Systems, 2000


   Description:
   ------------
	This demo performs host I/F registers test via host
	TORNADO-3x/E3x/P3x mainboard.

        T-PX/DDC4 on-board DSP is not utilized for this demo.

   Host TORNADO platform:
   ----------------------
	This demo utilize host TORNADO resources and runs in HOST mode.
	MIRAGE emulator or COFF-loader shall be used to upload
	code to host TORNADO board.

	TI CCS tools are required to recompile this demo and to
	upload code to host TORNADO on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
        on-board configuration switch:
          - HOST-mode
	  - DCM is installed onto TORNADO-3x/E3x/P3x mainboard
***********************************************************************/




#include <c3x_def.h>
#include <t3x_dsp.h>
#include <ddc4_h3x.h>


init_cpu()
{
   *C3X_PBUS_GC=T3X_PBUS_GC_DATA;
}



main()
{ int i;
  unsigned d;

   init_cpu();

 while(1)
 {
	// test CONTROL #1 register
   HTPXDDC4_SET_MGO;
   if(HTPXDDC4_CNTR1_RG_DATA!=HTPXDDC4_MRESET_GO) goto error;

   HTPXDDC4_SET_MRESET;
   if(HTPXDDC4_CNTR1_RG_DATA!=HTPXDDC4_MRESET_RESET) goto error;


	// test CONTROL #2 register
   for(i=0,d=0x1;i<4;i++)
     {
       HTPXDDC4_SET_CNTR2_RG(d);
       if(HTPXDDC4_CNTR2_RG_DATA!=d) goto error;
       d <<= 1;
     }

   HTPXDDC4_SET_CNTR2_RG(0x5);
   if(HTPXDDC4_CNTR2_RG_DATA!=0x5) goto error;

   HTPXDDC4_SET_CNTR2_RG(0);
   if(HTPXDDC4_CNTR2_RG_DATA!=0) goto error;

   HTPXDDC4_SET_CNTR2_RG(0xa);
   if(HTPXDDC4_CNTR2_RG_DATA!=0xa) goto error;



	// test IE register
   for(i=0,d=0x1;i<4;i++)
     {
       HTPXDDC4_SET_IE_RG(d);
       if(HTPXDDC4_IE_RG_DATA!=d) goto error;
       d <<= 1;
     }

   HTPXDDC4_SET_IE_RG(0xa);
   if(HTPXDDC4_IE_RG_DATA!=0xa) goto error;

   HTPXDDC4_SET_IE_RG(0);
   if(HTPXDDC4_IE_RG_DATA!=0) goto error;

   HTPXDDC4_SET_IE_RG(0x5);
   if(HTPXDDC4_IE_RG_DATA!=0x5) goto error;



	// test HIRQ_SEL register
   HTPXDDC4_SET_HIRQ_SEL_RG(0x1);
   if(HTPXDDC4_HIRQ_SEL_RG_DATA!=0x1) goto error;

   HTPXDDC4_SET_HIRQ_SEL_RG(0x2);
   if(HTPXDDC4_HIRQ_SEL_RG_DATA!=0x2) goto error;

   HTPXDDC4_SET_HIRQ_SEL_RG(0x8);
   if(HTPXDDC4_HIRQ_SEL_RG_DATA!=0x8) goto error;

   HTPXDDC4_SET_HIRQ_SEL_RG(0x0);
   if(HTPXDDC4_HIRQ_SEL_RG_DATA!=0x0) goto error;

   HTPXDDC4_SET_HIRQ_SEL_RG(0x9);
   if(HTPXDDC4_HIRQ_SEL_RG_DATA!=0x9) goto error;



    	// now test the values that have been left in registers
   if(   HTPXDDC4_CNTR1_RG_DATA!=HTPXDDC4_MRESET_RESET
      || HTPXDDC4_CNTR2_RG_DATA!=0xa
      || HTPXDDC4_IE_RG_DATA!=0x5
      || HTPXDDC4_HIRQ_SEL_RG_DATA!=0x9
     ) goto error;


	// now clear all registers and flags
   HTPXDDC4_SET_MRESET;
   if(HTPXDDC4_CNTR1_RG_DATA!=HTPXDDC4_MRESET_RESET) goto error;

   HTPXDDC4_SET_CNTR2_RG(0);
   if(HTPXDDC4_CNTR2_RG_DATA!=0) goto error;

   HTPXDDC4_SET_IE_RG(0);
   if(HTPXDDC4_IE_RG_DATA!=0) goto error;

   HTPXDDC4_SET_HIRQ_SEL_RG(0x0);
   if(HTPXDDC4_HIRQ_SEL_RG_DATA!=0x0) goto error;

   HTPXDDC4_CLR_DPRAM_ERR;
   HTPXDDC4_CLR_HPI_ERR;
   if(HTPXDDC4_HPI_ERR_DATA!=0 || HTPXDDC4_DPRAM_ERR_DATA!=0) goto error;
 }

  error:
    while(1) ;

}


