/********************************************************************
   TORNADO-PX/DDC4 DCM Demo Utility.
   Control Registers test. rev.1A
   (C) MicroLAB Systems, 2000


   Description:
   ------------
	This demo scans continuously control registers within
        the DSP environment.


   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources
	and runs in stand-alone mode. MIRAGE JTAG emulator and
	TI CCS tools are required to recompile this demo and to
	upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
        on-board configuration switch:
          - SA-mode
	  - no BOOT mode
***********************************************************************/


#include "ddc4_dsp.h"
#include "ddc4_dx.h"



void init_cpu()
 {
	TPXDDC4_init_cpu();
 }




main()
{ unsigned i,d,n;

   init_cpu();

   C54X_INT_DISABLE;

   n=0;
   TPXDDC4_set_mnmi_sel(TPXDDC4_MIRQ_SEL_OFF);
   if(TPXDDC4_mnmi_sel()!=TPXDDC4_MIRQ_SEL_OFF) goto error;


   while(1)
    {
	TPXDDC4_wdt_reset();

        n=1;
        d=TPXDDC4_sys_stat();
	if(   TPXDDC4_bmode()!= TPXDDC4_BMODE_NONE
	   || TPXDDC4_sa_mode()!= TPXDDC4_SA_MODE_ON
	  ) goto error;


        n=2;
        TPXDDC4_set_wdt_enable(TPXDDC4_WDT_DISABLE);
	if((d=TPXDDC4_wdt_enable())!=TPXDDC4_WDT_DISABLE) break;

        n=3;
        TPXDDC4_set_wdt_enable(TPXDDC4_WDT_ENABLE);
	if((d=TPXDDC4_wdt_enable())!=TPXDDC4_WDT_ENABLE) break;

        n=4;
        TPXDDC4_set_wdt_enable(TPXDDC4_WDT_DISABLE);
	if((d=TPXDDC4_wdt_enable())!=TPXDDC4_WDT_DISABLE) break;


        for(i=0;i<=63;i++)
	 {
	   TPXDDC4_set_mirq0_sel(i);
           TPXDDC4_set_mirq1_sel(~i);
           TPXDDC4_set_mirq2_sel(i+8);
           TPXDDC4_set_mirq3_sel(i+4);
	   TPXDDC4_set_xsl_fmt(i+15);

        n=5;
	   if((d=TPXDDC4_mirq0_sel())!=(i%32)) goto error;
        n=6;
	   if((d=TPXDDC4_mirq1_sel())!=((~i)%32)) goto error;
        n=7;
	   if((d=TPXDDC4_mirq2_sel())!=((i+8)%32)) goto error;
        n=8;
	   if((d=TPXDDC4_mirq3_sel())!=((i+4)%32)) goto error;
        n=9;
	   if((d=TPXDDC4_xsl_fmt())!=((i+15)%64)) goto error;


	 }


	   TPXDDC4_set_mirq0_sel(TPXDDC4_MIRQ_SEL_OFF);
           TPXDDC4_set_mirq1_sel(TPXDDC4_MIRQ_SEL_OFF);
           TPXDDC4_set_mirq2_sel(TPXDDC4_MIRQ_SEL_OFF);
           TPXDDC4_set_mirq3_sel(TPXDDC4_MIRQ_SEL_OFF);
           TPXDDC4_set_mnmi_sel(TPXDDC4_MIRQ_SEL_OFF);
	   TPXDDC4_set_xsl_fmt(0);





    }


error:
  while(1);

}



