/********************************************************************
   TORNADO-PX/DDC4 DCM Demo Utility.
   PH-DAC demo. rev.1A
   (C) MicroLAB Systems, 2000


   Description:
   ------------
	This demo writes SIN to PH-DAC.

   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources
	and runs in stand-alone mode. MIRAGE JTAG emulator and
	TI CCS tools are required to recompile this demo and to
	upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
        on-board configuration switch:
          - SA-mode
	  - no BOOT mode
***********************************************************************/

#include	"math.h"
#include	"c54x_def.h"
#include	"ddc4_dsp.h"
#include	"ddc4_dx.h"


#define	_CLEAR_TM_EVENT		*C54X_IFR=8
#define	_WAIT_TM_EVENT		while(!(*C54X_IFR & 8))



void init_cpu()
 {
  TPXDDC4_init_cpu();
 }

void init_sio()
{
	TPXDDC4_init_mcbsp2();

		//--- set 40 kHz sampling frequency for DACs
	*C54X_TM_TCR = (TPXDDC4_dsp_type()==TPXDDC4_DSP_TYPE_C5410) ? 0x0019:0x001F;
	*C54X_TM_PRD = 250;
	*C54X_TM_TCR = (TPXDDC4_dsp_type()==TPXDDC4_DSP_TYPE_C5410) ? 0x0009:0x000F;	// start timer

        	//--- clear TIMER interrupt request
	_CLEAR_TM_EVENT;
}



int dac_data[1000];

void main()
{  int i;

	init_cpu();
	init_sio();

	// initialize DAC array with SINUS data
	for(i=0;i<1000;i++)
		dac_data[i] = (int) ((float)(32000.0 * sin(2.0*3.14*((float)i)/1000.0)));

	// upload data fm array to PH-DAC
    i=0;
	while (1)
	 {
	  _WAIT_TM_EVENT;
	  _CLEAR_TM_EVENT;

	  TPXDDC4_write_phdac(dac_data[i]);
      i++;
	  if(i>=1000) i=0;
	 }

}

